
#include "mandel.h"
#include "stdlib.h"
#include "memory.h"

void main
  (
    int argc,
    char **argv
  ) 
{

  MandelInfo info;
  MPI_Status status;
  short *deep_table;

  MPI_Init(NULL, NULL);

  Mandel_SetupType();

  MPI_Recv(&info, 1, MandelInfoType, 0, MANDEL_TAG_INFO, MPI_COMM_WORLD, &status);
    
  while(!info.stop) {

    deep_table = (short *) calloc(info.size_x * info.size_y, sizeof(short));

    printf("Rendering Mandelbrot:\n");
    printf("x1 = %lf; y1 = %lf\n",info.x1,info.y1);
    printf("x2 = %lf; y2 = %lf\n",info.x2,info.y2);
    printf("size x = %d; size y = %d\n",info.size_x, info.size_y);

    Mandel_Render(info, deep_table);

    printf("Sending info...\n");
    MPI_Send(deep_table, info.size_x * info.size_y, MPI_SHORT, 0, MANDEL_TAG_DEEPTABLE, MPI_COMM_WORLD);

    free(deep_table);

    printf("Wait for more work...\n");
    MPI_Recv(&info, 1, MandelInfoType, 0, MANDEL_TAG_INFO, MPI_COMM_WORLD, &status);
  }

  printf("Ends...\n");

  MPI_Finalize();

}